# -*- encoding: cp1250 -*-

from mvc import *
from storage import SensorPosition

# CalibrationTable ##########################################################

class CalibrationTable(CompositeModel):
	_models = {
		'version': VersionModel('1.0'),
		'rot_zero': FloatModel(0.0),
		'tilt_zero': FloatModel(0.0),
		'sensors': ArrayModel(SensorPosition()),
	}
	def validator(self):
		if len(self.sensors) == 0:
			self.validator_failure("Seznam pozic idel nesm bt przdn", self.sensors)
			return

# CalibrationArm ##########################################################

def validate_arm_zero(val):
	if not -90.0 < val < 90.0: return "Nula ramene mus bt mezi -90 a +90 stupni."

def validate_sensor_dist(val):
	if not val > 0.0: return "Vzdlenost idla mus bt kladn"
	
class CalibrationArm(CompositeModel):
	_models = {
		'version': VersionModel('1.0'),
		'arm_zero': FloatModel(0.0, validate_arm_zero),
		'sensor_distance': FloatModel(1.0, validate_sensor_dist),
	}

# CalibrationLuxmeters ######################################################

def nonempty(str):
	if not str: return "Text nesm bt przdn"

class Luxmeters(CompositeModel):
	_models = {
		'version': VersionModel('1.0'),
		'luxmeters': ArrayModel(StrModel(validators = nonempty)),
	}
	def validator(self):
		if len(self.luxmeters) == 0:
			self.validator_failure("Seznam luxmetr nesm bt przdn", self.luxmeters)
			return
