import sys
import linecache
import random
import pdb
import traceback

def pause():
	sys.stdin.readline()

dbg = pdb.set_trace

print_stack = traceback.print_stack

import sys

def debug_func(f):
	def newf(*args, **kwargs):
		print f.func_name, args, kwargs
		f_result = f(*args, **kwargs)
		print f.func_name, "returned", f_result
		return f_result
	newf.__doc__ = f.__doc__
	return newf

def traceit(frame, event, arg):
	if event == "line":
		lineno = frame.f_lineno
		filename = frame.f_globals["__file__"]
		if filename == "<stdin>":
			filename = "traceit.py"
		if (filename.endswith(".pyc") or
			filename.endswith(".pyo")):
			filename = filename[:-1]
		name = frame.f_globals["__name__"]
		line = linecache.getline(filename, lineno)
		print u"%s:%s: %s" % (name, lineno, line.rstrip())
	return traceit

def start_tracing():
	sys.settrace(traceit)

def stop_tracing():
	sys.settrace(None)

def hotshot(stats_file, func, *func_args, **func_kwargs):
		import hotshot
		profile = hotshot.Profile(stats_file)
		print profile.runcall(func, *func_args, **func_kwargs)
		profile.close()

def hotshot_stats(stats_file):
	import hotshot.stats
	s = hotshot.stats.load(stats_file)
	s.strip_dirs()
	s.sort('cum')
	s.print_stats(40)

if __name__ == '__main__':
	def main():
		print "In main"
		for i in range(5):
			print i, random.randrange(0, 10)
		print "Done."

	sys.settrace(traceit)
	main()
