import wx
from wxPyPlot import PlotCanvas, PolyLine, PlotGraphics
from math import *
import pdb

class Diag(object):
	def __init__(self, a, b, d, delta):
		self.a, self.b, self.d, self.delta = a, b, d, delta

	def compute_alpha(self):
		#pdb.set_trace()
		alpha1 = atan2(self.b, self.a)
		p = sqrt(self.a**2 + self.b**2)
		gamma1 = asin(self.d*sin(self.delta)/p)
		alpha2 = pi-self.delta-gamma1
		alpha = alpha1 + alpha2
		return alpha

	def get_plot_graphics(self):
		alpha = self.compute_alpha()
		pt_d = (self.d*cos(alpha), self.d*sin(alpha))
		print alpha, pt_d
		lines = {
			'a': PolyLine(((0, 0), (self.a, 0)), width=2),
			'b': PolyLine(((self.a, 0), (self.a, self.b)), width = 2),
			'c': PolyLine(((self.a, self.b), pt_d), width = 1),
			'd': PolyLine((pt_d, (0, 0)), width = 2),
			'p': PolyLine(((0, 0), (self.a, self.b)), width = 1),
		}
		return PlotGraphics(lines.values(), "elevace -> naklopeni", "", "")

def deg2rad(d):
	return d/180.0*pi

def rad2deg(r):
	return r/pi*180.0

class AppFrame(wx.Frame):
	def __init__(self, parent, id, title):
		wx.Frame.__init__(self, parent, id, title, (-1, -1), (600, 400))

		# A status bar to tell people what's happening
		self.CreateStatusBar(1)
		
		self.client = PlotCanvas(self)
		#Create mouse event for showing cursor coords in status bar
		wx.EVT_LEFT_DOWN(self.client, self.OnMouseLeftDown)
		self.diag = Diag(5.5, -4.5, 2.5, deg2rad(300))
		self.client.Draw(self.diag.get_plot_graphics())

	def OnMouseLeftDown(self,event):
		s= "Left Mouse Down at Point: (%.4f, %.4f)" % self.client.GetXY(event)
		self.SetStatusText(s)
		event.Skip()

class MyApp(wx.App):
	def OnInit(self):
		frame = AppFrame(None, -1, "PlotCanvas")
		frame.Show(True)
		self.SetTopWindow(frame)
		return True

app = MyApp(0)
app.MainLoop()
